import { z } from 'zod/v4';
/**
 * When the payload is too large to be sent in a single message, it is offloaded to a storage service and a pointer to the offloaded payload is sent instead.
 * This schema represents the payload that is sent in place of the original payload.
 */
export declare const OFFLOADED_PAYLOAD_POINTER_PAYLOAD_SCHEMA: z.ZodObject<{
    offloadedPayloadPointer: z.ZodString;
    offloadedPayloadSize: z.ZodNumber;
}, z.core.$loose>;
export type OffloadedPayloadPointerPayload = z.output<typeof OFFLOADED_PAYLOAD_POINTER_PAYLOAD_SCHEMA>;
export declare function isOffloadedPayloadPointerPayload(value: unknown): value is OffloadedPayloadPointerPayload;
